Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15032)
@@ -8,4 +8,5 @@
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
@@ -17,7 +18,6 @@
 
       enabledExpressions = ExpressionTable.ExpressionNames.ToList();
-      enabledStacks = new Dictionary<StackTypes, bool>();
-
-      InitEnabledStacks();
+      expressionsPerStackCount = new Dictionary<StackTypes, int>();
+      InitExpressionsPerStackCount();
     }
 
@@ -27,11 +27,9 @@
     protected PushConfigurationBase(PushConfigurationBase origin, Cloner cloner) : base(origin, cloner) {
       enabledExpressions = origin.EnabledExpressions.ToList();
-      enabledStacks = origin.EnabledStacks.ToDictionary(x => x.Key, x => x.Value);
+      expressionsPerStackCount = origin.expressionsPerStackCount.ToDictionary(x => x.Key, x => x.Value);
     }
 
     [Storable]
-    private readonly Dictionary<StackTypes, bool> enabledStacks;
-
-    public IReadOnlyDictionary<StackTypes, bool> EnabledStacks { get { return enabledStacks; } }
+    private readonly Dictionary<StackTypes, int> expressionsPerStackCount;
 
     public event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
@@ -40,5 +38,10 @@
     protected readonly List<string> enabledExpressions;
 
-    public IList<string> EnabledExpressions
+    public bool IsStackEnabled(StackTypes type) {
+      int count;
+      return expressionsPerStackCount.TryGetValue(type, out count) && count > 0;
+    }
+
+    public IReadOnlyList<string> EnabledExpressions
     {
       get { return enabledExpressions; }
@@ -55,8 +58,18 @@
     }
 
-    private void InitEnabledStacks(bool state = true) {
+    private void InitExpressionsPerStackCount() {
       foreach (StackTypes type in Enum.GetValues(typeof(StackTypes))) {
-        if (!enabledStacks.ContainsKey(type) && type != StackTypes.None)
-          enabledStacks.Add(type, state);
+        if (type == StackTypes.None) continue;
+        expressionsPerStackCount.Add(type, 0);
+      }
+
+      foreach (var expressionName in ExpressionTable.ExpressionNames) {
+        var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == expressionName).Key;
+        var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+        expressionsPerStackCount[attribute.StackType]++;
+
+        foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues())
+          expressionsPerStackCount[additionalStackType]++;
       }
     }
@@ -64,18 +77,16 @@
     public void SetEnabledStacks(StackTypes types) {
       // Disable all
-      EnabledExpressions.Clear();
-
-      foreach (StackTypes type in Enum.GetValues(types.GetType())) {
+      enabledExpressions.Clear();
+
+      foreach (StackTypes type in Enum.GetValues(typeof(StackTypes))) {
         if (type == StackTypes.None) continue;
-        enabledStacks[type] = false;
-      }
-
-      foreach (var pair in ExpressionTable.StackDependencyToNamesTable) {
-        if (types.HasFlag(pair.Key)) {
-          foreach (var name in pair.Value) {
-            EnableExpression(name, true);
-          }
-        }
-      }
+        expressionsPerStackCount[type] = 0;
+      }
+
+      var expressionNames = ExpressionTable.StackDependencyToNamesTable
+        .Where(pair => types.HasFlag(pair.Key))
+        .SelectMany(pair => pair.Value);
+
+      EnableExpressions(expressionNames);
     }
 
@@ -92,5 +103,5 @@
           return (attribute.StackType | attribute.AdditionalStackDependencies)
             .ToEnumerable()
-            .All(st => enabledStacks.ContainsKey(st) && enabledStacks[st]);
+            .All(IsStackEnabled);
         });
 
@@ -98,10 +109,10 @@
     }
 
-    private void EnableExpressions(IEnumerable<string> names) {
-      foreach (var name in names.Except(EnabledExpressions))
-        EnabledExpressions.Add(name);
+    private void EnableExpressions(IEnumerable<string> expressionNames) {
+      foreach (var expressionName in expressionNames.Except(EnabledExpressions))
+        EnableExpression(expressionName, false);
 
       if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(names, new string[0]));
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(expressionNames, new string[0]));
       }
     }
@@ -119,86 +130,94 @@
     }
 
-    private void DisableExpressions(IEnumerable<string> names) {
-      foreach (var name in names.Intersect(EnabledExpressions))
-        EnabledExpressions.Remove(name);
+    private void DisableExpressions(IEnumerable<string> expressionNames) {
+      foreach (var expressionName in expressionNames.Intersect(EnabledExpressions))
+        DisableExpression(expressionName, false);
 
       if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(new string[0], names));
-      }
-    }
-
-    public void EnableExpression(string name, bool enableStackIfDisabled = false) {
-      if (EnabledExpressions.Contains(name)) return;
-
-      EnabledExpressions.Add(name);
-
-      if (enableStackIfDisabled) {
-        var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == name).Key;
-        var attribute = ExpressionTable.TypeToAttributeTable[type];
-        enabledStacks[attribute.StackType] = true;
-      }
-
-      if (EnabledExpressionsChanged != null) {
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(new string[0], expressionNames));
+      }
+    }
+
+    public void EnableExpression(string expressionName) {
+      EnableExpression(expressionName, true);
+    }
+
+    private void EnableExpression(string expressionName, bool triggerExpressionChanged) {
+      if (enabledExpressions.Contains(expressionName)) return;
+
+      var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == expressionName).Key;
+      var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+      enabledExpressions.Add(expressionName);
+      expressionsPerStackCount[attribute.StackType]++;
+      foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues())
+        expressionsPerStackCount[additionalStackType]++;
+
+      if (EnabledExpressionsChanged != null && triggerExpressionChanged) {
         EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(
-          new[] { name },
+          new[] { expressionName },
           new string[0]));
       }
     }
 
-    public void DisableExpression(string name, bool disableStackIfEnabled = false) {
-      if (!EnabledExpressions.Contains(name)) return;
-
-      EnabledExpressions.Remove(name);
-
-      if (disableStackIfEnabled) {
-        var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == name).Key;
-        var attribute = ExpressionTable.TypeToAttributeTable[type];
-        enabledStacks[attribute.StackType] = false;
-      }
-
-      if (EnabledExpressionsChanged != null) {
+    public void DisableExpression(string expressionName) {
+      DisableExpression(expressionName, true);
+    }
+
+    public void DisableExpression(string expressionName, bool triggerExpressionChanged) {
+      if (!EnabledExpressions.Contains(expressionName)) return;
+
+      var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == expressionName).Key;
+      var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+      enabledExpressions.Remove(expressionName);
+      expressionsPerStackCount[attribute.StackType]--;
+      foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues())
+        expressionsPerStackCount[additionalStackType]--;
+
+      if (EnabledExpressionsChanged != null && triggerExpressionChanged) {
         EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(
           new string[0],
-          new[] { name }));
-      }
-    }
-
-    public void EnableExpression<T>(bool enableStackIfDisabled = false) where T : Expression {
+          new[] { expressionName }));
+      }
+    }
+
+    public void EnableExpression<T>() where T : Expression {
       var attribute = ExpressionTable.TypeToAttributeTable[typeof(T)];
-      EnableExpression(attribute.ExpressionName, enableStackIfDisabled);
-    }
-
-    public void DisableExpression<T>(bool disableStackIfEnabled = false) where T : Expression {
+      EnableExpression(attribute.Name);
+    }
+
+    public void DisableExpression<T>() where T : Expression {
       var attribute = ExpressionTable.TypeToAttributeTable[typeof(T)];
-      DisableExpression(attribute.ExpressionName, disableStackIfEnabled);
-    }
-
-    public void SetExpression(string name, bool state, bool cascadeForStack = false) {
-      if (state) EnableExpression(name, cascadeForStack);
-      else DisableExpression(name, cascadeForStack);
-    }
-
-    public void SetExpression<T>(bool state, bool cascadeForStack = false) where T : Expression {
-      if (state) EnableExpression<T>(cascadeForStack);
-      else DisableExpression<T>(cascadeForStack);
-    }
-
-    public void EnableStack(StackTypes type, bool enableExpressions = true, bool enableDependencies = true) {
-      enabledStacks[type] = true;
-
-      if (enableExpressions) EnableExpressionOfStack(type);
-      if (enableDependencies) EnableExpressionDependentOnStack(type);
-    }
-
-    public void DisableStack(StackTypes type, bool disableExpressions = true, bool disableDependencies = true) {
-      enabledStacks[type] = false;
-
-      if (disableExpressions) DisableExpressionsOfStack(type);
-      if (disableDependencies) DisableExpressionsDependentOnStack(type);
-    }
-
-    public void SetStack(StackTypes type, bool state, bool setExpressions = true, bool setDependencies = true) {
-      if (state) EnableStack(type, setExpressions, setDependencies);
-      else DisableStack(type, setExpressions, setDependencies);
+      DisableExpression(attribute.Name);
+    }
+
+    public void SetExpression(string name, bool state) {
+      if (state) EnableExpression(name);
+      else DisableExpression(name);
+    }
+
+    public void SetExpression<T>(bool state) where T : Expression {
+      if (state) EnableExpression<T>();
+      else DisableExpression<T>();
+    }
+
+    public void EnableStack(StackTypes type, bool enableDependencies = false) {
+      EnableExpressionOfStack(type);
+
+      if (enableDependencies)
+        EnableExpressionDependentOnStack(type);
+    }
+
+    public void DisableStack(StackTypes type, bool disableDependencies = false) {
+      DisableExpressionsOfStack(type);
+
+      if (disableDependencies)
+        DisableExpressionsDependentOnStack(type);
+    }
+
+    public void SetStack(StackTypes type, bool state, bool setDependencies = false) {
+      if (state) EnableStack(type, setDependencies);
+      else DisableStack(type, setDependencies);
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15032)
@@ -192,5 +192,7 @@
 
     /// <summary>
-    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
+    /// Determines the likelyhood of smaller or bigger values.
+    /// x greater than 1 means that result is biased towards min.
+    /// x smaller than 1 means that result is biased towards max.
     /// </summary>
     public IValueParameter<DoubleValue> ParenthesesCloseBiasLevelParameter
@@ -206,5 +208,5 @@
 
     /// <summary>
-    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
+    /// Determines the maximum of blocks which will be closed.
     /// </summary>
     public IValueParameter<IntValue> MaxParenthesesCloseParameter
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 15032)
@@ -13,5 +13,5 @@
   ///     Pushes the logical AND of the top two BOOLEANs.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.AND")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.AND", "Pushes the logical AND of the top two BOOLEANs.")]
   [StorableClass]
   public class BooleanAndExpression : StatelessExpression {
@@ -36,5 +36,5 @@
   ///     Pushes the logical OR of the top two BOOLEANs.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.OR")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.OR", "Pushes the logical OR of the top two BOOLEANs.")]
   [StorableClass]
   public class BooleanOrExpression : StatelessExpression {
@@ -59,5 +59,5 @@
   ///     Pushes the logical NOT of the top BOOLEAN.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.NOT")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.NOT", "Pushes the logical NOT of the top BOOLEAN.")]
   [StorableClass]
   public class BooleanNotExpression : StatelessExpression {
@@ -78,5 +78,5 @@
   ///     Pushes FALSE if the top FLOAT is 0.0, or TRUE otherwise.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.FROMFLOAT", StackTypes.Float)]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.FROMFLOAT", "Pushes FALSE if the top FLOAT is 0.0, or TRUE otherwise.", StackTypes.Float)]
   [StorableClass]
   public class BooleanFromFloatExpression : StatelessExpression {
@@ -98,5 +98,5 @@
   ///     Pushes FALSE if the top INTEGER is 0, or TRUE otherwise.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.FROMINTEGER", StackTypes.Integer)]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.FROMINTEGER", "Pushes FALSE if the top INTEGER is 0, or TRUE otherwise.", StackTypes.Integer)]
   [StorableClass]
   public class BooleanFromIntegerExpression : StatelessExpression {
@@ -118,5 +118,5 @@
   ///     Pushes the logical AND of the top two BOOLEANs, whereby the first value is inverted first.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.INVERT_FIRST_THEN_AND")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.INVERT_FIRST_THEN_AND", "Pushes the logical AND of the top two BOOLEANs, whereby the first value is inverted first.")]
   [StorableClass]
   public class BooleanInvertFirstThenAnd : StatelessExpression {
@@ -141,5 +141,5 @@
   ///     Pushes the logical AND of the top two BOOLEANs, whereby the second value is inverted first.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.INVERT_SECOND_THEN_AND")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.INVERT_SECOND_THEN_AND", "Pushes the logical AND of the top two BOOLEANs, whereby the second value is inverted first.")]
   [StorableClass]
   public class BooleanInvertSecondThenAnd : StatelessExpression {
@@ -165,5 +165,5 @@
   ///     Pushes the xor of the top tow BOOLEANs
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.XOR")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.XOR", "Pushes the xor of the top tow BOOLEANs.")]
   [StorableClass]
   public class BooleanXorExpression : StatelessExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15032)
@@ -8,5 +8,12 @@
   using Stack;
 
-  [PushExpression(StackTypes.Char, "CHAR.ISWHITESPACE", StackTypes.Boolean)]
+  /// <summary>
+  /// Pushes TRUE onto the BOOLEAN stack if the top char represents a whitespace char, otherwise FALSE.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.ISWHITESPACE",
+    "Pushes TRUE onto the BOOLEAN stack if the top char represents a whitespace char, otherwise FALSE.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CharIsWhitespaceExpression : StatelessExpression {
@@ -25,5 +32,12 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.ISLETTER", StackTypes.Boolean)]
+  /// <summary>
+  /// Pushes TRUE onto the CHAR stack if the top char represents a letter, otherwise FALSE.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.ISLETTER",
+    "Pushes TRUE onto the CHAR stack if the top char represents a letter, otherwise FALSE.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CharIsLetterExpression : StatelessExpression {
@@ -42,5 +56,12 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.ISDIGIT", StackTypes.Boolean)]
+  /// <summary>
+  /// Pushes TRUE onto the CHAR stack if the top char represents a digit, otherwise FALSE.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.ISDIGIT",
+    "Pushes TRUE onto the CHAR stack if the top char represents a digit, otherwise FALSE.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CharIsDigitExpression : StatelessExpression {
@@ -59,5 +80,12 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.FROMINTEGER", StackTypes.Integer)]
+  /// <summary>
+  /// Takes the top integer, converts it to an char using ASCII encoding and pushes this char onto the CHAR stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.FROMINTEGER",
+    "Takes the top integer, converts it to an char using ASCII encoding and pushes this char onto the CHAR stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CharFromIntegerExpression : StatelessExpression {
@@ -78,5 +106,12 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.FROMFLOAT", StackTypes.Float)]
+  /// <summary>
+  /// Takes the top float, casts it to an integer, converts it to an char using ASCII encoding and pushes this char onto the CHAR stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.FROMFLOAT",
+    "Takes the top float, casts it to an integer, converts it to an char using ASCII encoding and pushes this char onto the CHAR stack.",
+    StackTypes.Float)]
   [StorableClass]
   public class CharFromFloatExpression : StatelessExpression {
@@ -97,5 +132,12 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.ALLFROMSTRING", StackTypes.String)]
+  /// <summary>
+  /// Takes the top string and pushes the chars of this string onto the CHAR stack in reversed order.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.ALLFROMSTRING",
+    "Takes the top string and pushes the chars of this string onto the CHAR stack in reversed order.",
+    StackTypes.String)]
   [StorableClass]
   public class CharAllFromStringExpression : StatelessExpression {
